SystemOrganization addCategory: #Rango!
SystemOrganization addCategory: #'Rango-Tests'!

Object subclass: #Rango
	instanceVariableNames: 'start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango'!

!Rango class methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 17:07'!
rangoUniversal 
|universalRange startDate endDate|

startDate:= DateAndTime today.
endDate:= DateAndTime year: 9999 month: 12 day: 31 hour: 23 minute: 59.

universalRange := Rango new.
universalRange start: startDate; end: endDate.

^universalRange .! !

!Rango methodsFor: 'accessors' stamp: 'LucasGiudice 4/16/2012 11:29'!
end
 ^end.! !

!Rango methodsFor: 'accessors' stamp: 'LucasGiudice 4/16/2012 11:29'!
end: anEnd
 end := anEnd! !

!Rango methodsFor: 'comparing' stamp: 'LucasGiudice 4/16/2012 19:58'!
equals: aRange
	^ self start = aRange start and: [ self end = aRange end.].! !

!Rango methodsFor: 'comparing' stamp: 'LucasGiudice 4/18/2012 17:18'!
includeArgument: anArgument

^ anArgument > self start and: [anArgument < self end]
! !

!Rango methodsFor: 'comparing' stamp: 'LucasGiudice 4/16/2012 20:05'!
includes: aRange

^ (self includeArgument: aRange start) and: [self includeArgument: aRange end].
! !

!Rango methodsFor: 'comparing' stamp: 'LucasGiudice 4/18/2012 10:15'!
overlaps: aRange

"Juro que anda... se me cago la otra imagen donde tenia hechos los tests y es una paja hacerlos de nuevo :P"

^(self includes: aRange) or:[ (self includeArgument: aRange start)
								or: [ (self includeArgument: aRange end ) ] 
							].! !

!Rango methodsFor: 'accessors' stamp: 'Paul 4/16/2012 22:00'!
size
"Devuelve el taman~o del Rango"

 ^end - start.! !

!Rango methodsFor: 'accessors' stamp: 'LucasGiudice 4/16/2012 11:28'!
start
^start! !

!Rango methodsFor: 'accessors' stamp: 'LucasGiudice 4/16/2012 11:29'!
start: aStart
 start := aStart! !

!Rango methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 18:36'!
startingOn: anArgument
"recibe una fecha, devuelve un nuevo rango que empieze en esa fecha y no tenga fin... mas o menos, el final es el fin del mundo que, como todos sabemos, es el 31/12/9999 a las 23.59 :P"

	|aRange endOfTheWorld|
	
	endOfTheWorld :=DateAndTime  year: 9999 month: 12 day: 31 hour: 23 minute: 59.
	
	aRange:= Rango new.
	aRange start: anArgument;
			end: endOfTheWorld.
	
	^aRange.
! !

!Rango methodsFor: 'operators' stamp: 'LucasGiudice 4/18/2012 17:50'!
substract: aRange
"OJO: modifica a self y adems devuelve un Rango nuevo."

|newRange|
newRange:= Rango new.
(self includes: aRange) ifTrue: [
		newRange end: self end.
		newRange start: aRange end.
		self end: aRange start. 
		^newRange.]
	ifFalse: [self error: 'no se puede sustraer un rango a otro si el ltimo no incluye al primero'].! !

TestCase subclass: #RangoIncludes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango-Tests'!

!RangoIncludes methodsFor: 'tests' stamp: 'LucasGiudice 4/16/2012 20:21'!
setUp 

| rangoUno rangoDos rangoTres |
rangoUno:= Rango new.
rangoDos:= Rango new.
rangoTres := Rango new.

rangoUno start: 10; end: 100.

rangoDos start: 9; end: 50.

rangoTres start: 11; end: 30.
! !

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/16/2012 21:28'!
testIncludesDateAndTime
| inicio fin unRangoGrande otroRangoChico|

inicio := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 15.
fin := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 15.

unRangoGrande := Rango new.
unRangoGrande start: inicio.
unRangoGrande end: fin.

inicio := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 30.
fin := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 00.

otroRangoChico := Rango new.
otroRangoChico start: inicio.
otroRangoChico end: fin.

self assert: ( unRangoGrande includes: otroRangoChico)
 
! !

!RangoIncludes methodsFor: 'tests' stamp: 'LucasGiudice 4/18/2012 17:34'!
testIncludesDateAndTimeEquals
| inicio fin unRangoGrande otroRangoIgual|

inicio := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 15.
fin := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 15.

unRangoGrande := Rango new.
unRangoGrande start: inicio.
unRangoGrande end: fin.

otroRangoIgual := Rango new.
otroRangoIgual start: inicio.
otroRangoIgual end: fin.

self assert: ( unRangoGrande includes: otroRangoIgual)not
 
! !

!RangoIncludes methodsFor: 'tests' stamp: 'LucasGiudice 4/16/2012 20:22'!
testIncludesEnRangoNumerico
| unoIncluyeDos  rangoUno rangoDos|

rangoUno:= Rango new.
rangoDos:= Rango new.

rangoUno start: 10; end: 100.

rangoDos start: 11; end: 50.

unoIncluyeDos := rangoUno includes: rangoDos.
 
self assert:  unoIncluyeDos = true! !

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/16/2012 21:30'!
testNotIncludesDateAndTime
| inicio fin unRangoGrande otroRangoChico|

inicio := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 15.
fin := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 15.

unRangoGrande := Rango new.
unRangoGrande start: inicio.
unRangoGrande end: fin.

inicio := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 30.
fin := DateAndTime year: 2012 month: 04 day: 16 hour: 33  minute: 00.

otroRangoChico := Rango new.
otroRangoChico start: inicio.
otroRangoChico end: fin.

self assert: ( unRangoGrande includes: otroRangoChico) not.
 
! !

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/16/2012 21:32'!
testNotIncludesDateAndTimeIntersection
| inicio fin unRangoGrande otroRangoChico|

inicio := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 15.
fin := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 15.

unRangoGrande := Rango new.
unRangoGrande start: inicio.
unRangoGrande end: fin.

inicio := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 00.
fin := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 00.

otroRangoChico := Rango new.
otroRangoChico start: inicio.
otroRangoChico end: fin.

self assert: ( unRangoGrande includes: otroRangoChico) not.
 
! !

TestCase subclass: #RangoSize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango-Tests'!

!RangoSize methodsFor: 'tests' stamp: 'Paul 4/16/2012 22:14'!
testSizeDateAndTime
	"Prueba el metodo con los DateAndTime"

	| inicio fin unRango duracionEsperada |
	inicio := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 21
		minute: 0.
	fin := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 22
		minute: 0.
	unRango := Rango new.
	unRango start: inicio.
	unRango end: fin.
	duracionEsperada := Duration
		days: 0
		hours: 1
		minutes: 0
		seconds: 0.
	self assert: duracionEsperada equals: unRango size! !

!RangoSize methodsFor: 'tests' stamp: 'Paul 4/16/2012 22:14'!
testSizeNumerico
	"Prueba el metodo con los numeros"

	| inicio fin unRango |
	inicio := 1.
	fin := 3.
	unRango := Rango new.
	unRango start: inicio.
	unRango end: fin.
	self assert: 2 equals: unRango size! !

TestCase subclass: #TestRangoOverlaps
	instanceVariableNames: 'rangoUno rangoDos rangoCuatro'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango-Tests'!

!TestRangoOverlaps methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 18:24'!
setUp 

| inicioRango1 finRango1 inicioRango2 finRango2 inicioRango4 finRango4 |


inicioRango1 := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 15.
finRango1 := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 15.

inicioRango2 := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 45.
finRango2 := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 45.

inicioRango4 := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 45.
finRango4 := DateAndTime year: 2012 month: 04 day: 16 hour: 23  minute: 45.

rangoUno:= Rango new.
rangoUno start: inicioRango1; end: finRango1.

rangoDos:= Rango new.
rangoDos start: inicioRango2; end: finRango2.

rangoCuatro:= Rango new.
rangoCuatro start: inicioRango4; end: finRango4.

! !

!TestRangoOverlaps methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 17:45'!
testDosOverlapsCuatro

rangoDos overlaps: rangoCuatro.

self assert: (rangoDos overlaps: rangoCuatro) not.
! !

!TestRangoOverlaps methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 17:42'!
testUnoOverlapsDos

rangoUno overlaps: rangoDos.

self assert: (rangoUno overlaps: rangoDos).
! !

TestCase subclass: #TestRangoStartingOn
	instanceVariableNames: 'rangoUno rangoTres'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango-Tests'!

!TestRangoStartingOn methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 18:33'!
setUp 
 
|inicioRango1  finRango1  inicioRango3 finRango3 |

inicioRango1 := DateAndTime year: 2012 month: 04 day: 18 hour: 0  minute: 0.
finRango1 := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 15.

 
inicioRango3 := DateAndTime year: 2012 month: 04 day: 18 hour: 0  minute: 0.
finRango3 := DateAndTime year: 9999 month: 12 day: 31 hour: 23  minute: 59.



rangoUno:= Rango new.
rangoUno start: inicioRango1; end: finRango1.

rangoTres:= Rango new.
rangoTres start: inicioRango3; end: finRango3.
! !

!TestRangoStartingOn methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 18:35'!
testUnoStartingOnUnaFecha

| aRange |
aRange := rangoUno startingOn: rangoUno start.

self assert: (rangoTres equals: aRange).! !

TestCase subclass: #TestRangoSubstract
	instanceVariableNames: 'rangoUno rangoDos rangoCuatro rangoTres'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango-Tests'!

!TestRangoSubstract methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 18:24'!
setUp 
 
| inicioRango1 finRango1 inicioRango2 finRango2 inicioRango4 finRango4 inicioRango3 finRango3 |

inicioRango1 := DateAndTime year: 2012 month: 04 day: 16 hour: 19  minute: 15.
finRango1 := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 15.

inicioRango2 := DateAndTime year: 2012 month: 04 day: 16 hour: 20  minute: 45.
finRango2 := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 45.
 
inicioRango3 := DateAndTime year: 2012 month: 04 day: 16 hour: 19  minute: 15.
finRango3 := DateAndTime year: 2012 month: 04 day: 16 hour: 20  minute: 45.

inicioRango4 := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 45.
finRango4 := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 15.

rangoUno:= Rango new.
rangoUno start: inicioRango1; end: finRango1.

rangoDos:= Rango new.
rangoDos start: inicioRango2; end: finRango2.

rangoTres:= Rango new.
rangoTres start: inicioRango3; end: finRango3.

rangoCuatro:= Rango new.
rangoCuatro start: inicioRango4; end: finRango4.

"si substraigo el rango dos del rango uno, el rango uno va a quedar como el rango tres y va a devolver el rango cuatro"! !

!TestRangoSubstract methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 18:08'!
testUnoSubstractDos
"si substraigo el rango dos del rango uno, el rango uno va a quedar como el rango tres y va a devolver el rango cuatro"

|unRango|

unRango := rangoUno substract: rangoDos.

self assert: ( unRango equals: rangoCuatro ).
self assert: ( rangoUno equals: rangoTres ).! !
